BigFloat -

# struct BigFloat

- BigFloat
- Float
- Number
- Value
- Object

## Overview

A `BigFloat` can represent arbitrarily large floats.

It is implemented under the hood with GMP.

## Included Modules

- Comparable(Float)
- Comparable(BigFloat)
- Comparable(Int)

## Defined in:

## Constructors

- .new(num : Float, precision : Int)
- .new(str : String)
- .new(num : BigInt)
- .new(num : BigRational)
- .new(num : BigFloat)
- .new(num : Int8 | Int16 | Int32)
- .new(num : UInt8 | UInt16 | UInt32)
- .new(num : Int64)
- .new(num : UInt64)
- .new(num : Number)
- .new(mpf : LibGMP::MPF)
- .new
- .new(&block)

## Class Method Summary

- .default_precision
- .default_precision=(prec : Int)

## Instance Method Summary

- #*(other : Number)
- #**(other : Int)
- #+(other : Number)
- #-(other : Number)
- #-
- #/(other : Number)
- #//(other : Number)
- #<=>(other : BigFloat)
- #<=>(other : BigInt)
- #<=>(other : Float32 | Float64)
- #<=>(other : Number)
- #abs
- #ceil
- #clone
- #floor
- #hash(hasher)

  TODO improve this

- #to_big_f
- #to_f
- #to_f!
- #to_f32
- #to_f32!
- #to_f64
- #to_f64!
- #to_i
- #to_i!
- #to_i16
- #to_i16!
- #to_i32
- #to_i32!
- #to_i64
- #to_i64!
- #to_i8
- #to_i8!
- #to_s(io : IO) : Nil
- #to_u
- #to_u!
- #to_u16
- #to_u16!
- #to_u32
- #to_u32!
- #to_u64
- #to_u64!
- #to_u8
- #to_u8!
- #to_unsafe
- #trunc

### Instance methods inherited from module `Comparable(Float)`

<(other : T) <, <=(other : T) <=, <=>(other : T) <=>, ==(other : T) ==, >(other : T) >, >=(other : T) >=

### Instance methods inherited from module `Comparable(BigFloat)`

<(other : T) <, <=(other : T) <=, <=>(other : T) <=>, ==(other : T) ==, >(other : T) >, >=(other : T) >=

### Instance methods inherited from module `Comparable(Int)`

<(other : T) <, <=(other : T) <=, <=>(other : T) <=>, ==(other : T) ==, >(other : T) >, >=(other : T) >=

### Instance methods inherited from struct `Float`

%(other) %, - -, //(other) //, <=>(other : BigDecimal)
<=>(other : BigRational)
<=>(other : BigInt) <=>, days : Time::Span days, fdiv(other) fdiv, finite? finite?, hash(hasher) hash, hours : Time::Span hours, infinite? infinite?, microseconds : Time::Span microseconds, milliseconds : Time::Span milliseconds, minutes : Time::Span minutes, modulo(other) modulo, nan? nan?, nanoseconds : Time::Span nanoseconds, remainder(other) remainder, seconds : Time::Span seconds, to_big_d to_big_d, to_big_i : BigInt to_big_i, to_big_r to_big_r, to_io(io : IO, format : IO::ByteFormat) to_io, to_json(json : JSON::Builder) to_json, to_json_object_key to_json_object_key, weeks : Time::Span weeks

### Constructor methods inherited from struct `Float`

from_io(io : IO, format : IO::ByteFormat) : self from_io

### Instance methods inherited from module `Comparable(BigDecimal)`

<(other : T) <, <=(other : T) <=, <=>(other : T) <=>, ==(other : T) ==, >(other : T) >, >=(other : T) >=

### Instance methods inherited from module `Comparable(BigRational)`

<(other : T) <, <=(other : T) <=, <=>(other : T) <=>, ==(other : T) ==, >(other : T) >, >=(other : T) >=

### Instance methods inherited from module `Comparable(BigInt)`

<(other : T) <, <=(other : T) <=, <=>(other : T) <=>, ==(other : T) ==, >(other : T) >, >=(other : T) >=

### Instance methods inherited from struct `Number`

*(other : Complex)
*(other : BigFloat) *, +(other : BigFloat)
+(other : Complex)
+ +, -(other : Complex)
-(other : BigFloat) -, /(other : Complex)
/(other : BigFloat) /, //(other : BigFloat) //, <=>(other : BigFloat)
<=>(other) : Int32? <=>, ==(other : Complex) ==, abs abs, abs2 abs2, cis cis, clamp(min, max)
clamp(range : Range) clamp, divmod(number) divmod, format(io : IO, separator = '.', delimiter = ',', decimal_places : Int? = nil, *, group : Int = 3, only_significant : Bool = false) : Nil
format(separator = '.', delimiter = ',', decimal_places : Int? = nil, *, group : Int = 3, only_significant : Bool = false) : String format, humanize(io : IO, precision = 3, separator = '.', delimiter = ',', *, base = 10 ** 3, significant = true, prefixes : Indexable = SI_PREFIXES) : Nil
humanize(precision = 3, separator = '.', delimiter = ',', *, base = 10 ** 3, significant = true, prefixes : Proc) : Nil
humanize(precision = 3, separator = '.', delimiter = ',', *, base = 10 ** 3, significant = true, &block) : String
humanize(io : IO, precision = 3, separator = '.', delimiter = ',', *, base = 10 ** 3, significant = true, &prefixes : Int32, Float64 -> Tuple(Int32, UNDERSCORE) | Tuple(Int32, UNDERSCORE, Bool)) : Nil
humanize(precision = 3, separator = '.', delimiter = ',', *, base = 10 ** 3, significant = true, prefixes = SI_PREFIXES) : String
humanize(io : IO, precision = 3, separator = '.', delimiter = ',', *, base = 10 ** 3, significant = true, prefixes : Proc) : Nil humanize, i i, round(digits = 0, base = 10) round, sign sign, significant(digits, base = 10) significant, step(*, to = nil, by = 1)
step(*, to = nil, by = 1, &block) step, to_big_f to_big_f, to_c to_c, to_yaml(yaml : YAML::Nodes::Builder) to_yaml, zero? : Bool zero?

### Constructor methods inherited from struct `Number`

zero : self zero

### Class methods inherited from struct `Number`

si_prefix(magnitude : Int, prefixes = SI_PREFIXES) : Char? si_prefix

### Instance methods inherited from module `Comparable(BigFloat)`

<(other : T) <, <=(other : T) <=, <=>(other : T) <=>, ==(other : T) ==, >(other : T) >, >=(other : T) >=

### Instance methods inherited from module `Comparable(Number)`

<(other : T) <, <=(other : T) <=, <=>(other : T) <=>, ==(other : T) ==, >(other : T) >, >=(other : T) >=

### Instance methods inherited from struct `Value`

==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, class class, dup dup, hash(hasher)
hash hash, inspect(io : IO) : Nil
inspect : String inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&block) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&block) try, unsafe_as(type : T.class) forall T unsafe_as

### Constructor methods inherited from class `Object`

from_json(string_or_io, root : String) : self
from_json(string_or_io) : self from_json, from_yaml(string_or_io : String | IO) : self from_yaml

## Constructor Detail

def self.new(num : Float, precision : Int) #
def self.new(str : String) #
def self.new(num : BigInt) #
def self.new(num : BigRational) #
def self.new(num : BigFloat) #
def self.new(num : Int8 | Int16 | Int32) #
def self.new(num : UInt8 | UInt16 | UInt32) #
def self.new(num : Int64) #
def self.new(num : UInt64) #
def self.new(num : Number) #
def self.new(mpf : LibGMP::MPF) #
def self.new #
def self.new(&block) #

## Class Method Detail

def self.default_precision #
def self.default_precision=(prec : Int) #

## Instance Method Detail

def *(other : Number) #
def **(other : Int) #
def +(other : Number) #
def -(other : Number) #
def - #
def /(other : Number) #
def //(other : Number) #
def <=>(other : BigFloat) #
def <=>(other : BigInt) #
def <=>(other : Float32 | Float64) #
def <=>(other : Number) #
def abs #
def ceil #
def clone #
def floor #
def hash(hasher) #

TODO improve this

def to_big_f #
def to_f #
def to_f! #
def to_f32 #
def to_f32! #
def to_f64 #
def to_f64! #
def to_i #
def to_i! #
def to_i16 #
def to_i16! #
def to_i32 #
def to_i32! #
def to_i64 #
def to_i64! #
def to_i8 #
def to_i8! #
def to_s(io : IO) : Nil #
def to_u #
def to_u! #
def to_u16 #
def to_u16! #
def to_u32 #
def to_u32! #
def to_u64 #
def to_u64! #
def to_u8 #
def to_u8! #
def to_unsafe #
def trunc #